const byte POT = A3;

void setup() {
  for (int i = 0; i <= 11; i++) {
    pinMode(i, OUTPUT);  
  }
  for (int i = 8; i <= 11; i++) {
    digitalWrite(i, HIGH);
  }
}

void loop() {
  int potValue = analogRead(POT);
  displayNumber(potValue);  
}

void displayNumber(int number){
  byte digit = 1;
  if (number > 0) {
    while (number > 0) {
      int shownumber = number % 10;
      number = number / 10;
      displayDigit(digit, shownumber, 1);
      delay(2);
      displayDigit(digit, shownumber, 0);
      digit ++;
    }
    while (digit <= 4) {
      delay(2);
      digit++;
    }
  } else {
    displayDigit(1, 0, 1);
    delay(2);
    displayDigit(1, 0, 0);
    delay(6);
  }
}

void displayDigit(byte digit, byte number, bool show){
  //                     ABCDEFG.
  const byte DIGIT[] = {B11111100,  // 0
                        B01100000,  // 1
                        B11011010,  // 2
                        B11110010,  // 3
                        B01100110,  // 4
                        B10110110,  // 5
                        B10111110,  // 6
                        B11100000,  // 7
                        B11111110,  // 8
                        B11110110}; // 9
  if (show) {
    PORTD = DIGIT[number];
    digitalWrite(7+digit, LOW);    
  } else {
    digitalWrite(7+digit, HIGH);
  }
}
