volatile byte display8x8[8] = {0, 0, 0, 0, 0, 0, 0, 0};
byte animationDelay = 20;

void setup() {
  for (int i = 0; i <= 15; i++) {
    pinMode(i, OUTPUT);  
  }
  for (int i = 0; i <= 7; i++) {
    digitalWrite(i, HIGH);
  }
  TCCR2A = 0;
  TCCR2B = 0;
  bitWrite(TCCR2B, CS20, 1);
  bitWrite(TCCR2B, CS21, 1);
  bitWrite(TCCR2B, CS22, 1);
  noInterrupts();
  bitWrite(TIMSK2, TOIE2, 1);
  interrupts();  
}

void loop() {
  for (int j = 0; j <= 3; j++) {
    for (int i = j; i <= 7-j; i++) {
      display8x8[i] |= (B10000000 >> j);
      delay(animationDelay);
    }
    for (int i = 6-j; i >= j; i--) {
      display8x8[7-j] |= (1 << i);
      delay(animationDelay);
    }
    for (int i = 6-j; i >= j; i--) {
      display8x8[i] |= (1 << j);
      delay(animationDelay);
    }
    for (int i = 1+j; i <= 6-j; i++) {
      display8x8[j] |= (1 << i);
      delay(animationDelay);
    }
  }
  for (int j = 3; j >= 0; j--) {
    for ( int i = 6-j; i >= 1+j; i--) {
      display8x8[j] &= ~(1 << i);
      delay(animationDelay);
    }  
    for (int i = j; i <= 6-j; i++) {
      display8x8[i] &= ~(1 << j);
      delay(animationDelay);
    }
    for (int i = j; i <= 6-j; i++) {
      display8x8[7-j] &= ~(1 << i);
      delay(animationDelay);
    }
    for (int i = 7-j; i >= j; i--) {
      display8x8[i] &= ~(B10000000 >> j);
      delay(animationDelay);
    }
  }
}

ISR(TIMER2_OVF_vect) {
  for (byte column = 0; column <=7; column++) {
    PORTB = display8x8[column] & B00111111;
    digitalWrite(14, (display8x8[column] & B01000000) >> 6);
    digitalWrite(15, (display8x8[column] & B10000000) >> 7);
    digitalWrite(column, LOW);
    delay(1);
    digitalWrite(column, HIGH);
  }
}
