volatile byte display8x8[] = {0, 0, 0, 0, 0, 0, 0, 0};

const byte SMILEY1[] = {B01111100,  // 0 stupac
                        B10000010,  // 1 stupac
                        B10101001,  // 2 stupac
                        B10000101,  // 3 stupac
                        B10000101,  // 4 stupac
                        B10101001,  // 5 stupac
                        B10000010,  // 6 stupac
                        B01111100}; // 7 stupac
                       
const byte SMILEY2[] = {B01111100,  // 0 stupac
                        B10000010,  // 1 stupac
                        B10001001,  // 2 stupac
                        B10000101,  // 3 stupac
                        B10000101,  // 4 stupac
                        B10001001,  // 5 stupac
                        B10000010,  // 6 stupac
                        B01111100}; // 7 stupac
const byte T1 = A5;

void setup() {
  for ( int i = 0; i <= 15; i++) {
    pinMode(i, OUTPUT);  
  }
  for (int i = 0; i <= 7; i++) {
    digitalWrite(i, HIGH);
  }
  pinMode(T1, INPUT_PULLUP);
  TCCR2A = 0;
  TCCR2B = 0;
  bitWrite(TCCR2B, CS20, 1);
  bitWrite(TCCR2B, CS21, 1);
  bitWrite(TCCR2B, CS22, 1);
  noInterrupts();
  bitWrite(TIMSK2, TOIE2, 1);
  interrupts();  
}

void loop() {
  if (digitalRead(T1) == 0) {
    for (int i = 0; i <= 7; i++){
      display8x8[i] = SMILEY2[i];
    }
  } else {
    for (int i = 0; i <= 7; i++){
      display8x8[i] = SMILEY1[i];
    }
  }
}


ISR(TIMER2_OVF_vect) {
  for (byte column = 0; column <=7; column++) {
    PORTB = display8x8[column] & B00111111;
    digitalWrite(14, (display8x8[column] & B01000000) >> 6);
    digitalWrite(15, (display8x8[column] & B10000000) >> 7);
    digitalWrite(column, LOW);
    delay(1);
    digitalWrite(column, HIGH);
  }
}
